#pragma semicolon 1

#include <sourcemod>
#include <sdktools_functions>

public Plugin:myinfo = 
{
	name	= "TK Punishment",
	author	= "wS / Schmidt",
	version	= "1.1",
	url		= "http://world-source.ru/"
};

new Handle:g_Menu;
new g_Id[MAXPLAYERS + 1];

public OnPluginStart()
{
	g_Menu = CreateMenu(g_Menu_CallBack);
	SetMenuTitle(g_Menu, "Меню Наказаний\n \n");
	SetMenuExitButton(g_Menu, false);
	AddMenuItem(g_Menu, "1", "Простить");
	AddMenuItem(g_Menu, "2", "Убить");
	AddMenuItem(g_Menu, "3", "Отобрать всё оружие");
	AddMenuItem(g_Menu, "4", "Поджечь");
	AddMenuItem(g_Menu, "5", "Сделать слепым");
	AddMenuItem(g_Menu, "6", "Заморозить");
	AddMenuItem(g_Menu, "7", "Забрать 50% денег");
	AddMenuItem(g_Menu, "8", "Закопать");
	AddMenuItem(g_Menu, "9", "Превратить в черепаху");

	HookEvent("player_death", player_death);
}

public OnClientPutInServer(client)
{
	g_Id[client] = 0;
}

public player_death(Handle:event, const String:name[], bool:silent)
{
	new attacker_userid = GetEventInt(event, "attacker");
	if (attacker_userid < 1)
		return;

	new attacker_client = GetClientOfUserId(attacker_userid);
	if (attacker_client < 1)
		return;

	new victim = GetClientOfUserId(GetEventInt(event, "userid"));
	if (attacker_client != victim && !IsFakeClient(victim) && GetClientTeam(attacker_client) == GetClientTeam(victim))
	{
		g_Id[victim] = attacker_userid;
		DisplayMenu(g_Menu, victim, 0);
		PrintToChat(victim, "[ TK_Punishment ] %N убил вас..", attacker_client);
	}
}

public g_Menu_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action != MenuAction_Select)
		return;

	new target = GetClientOfUserId(g_Id[client]);
	if (target < 1)
	{
		PrintToChat(client, "[ TK_Punishment ] Игрок не найден");
		return;
	}

	if (item > 0 && !IsPlayerAlive(target))
	{
		PrintToChat(client, "[ TK_Punishment ] Подождите, пока %N не оживёт", target);
		DisplayMenu(g_Menu, client, 0);
		return;
	}

	decl String:text[3];
	if (!GetMenuItem(menu, item, text, 3))
		return;

	new x = StringToInt(text);
	if (x == 1)
	{
		PrintToChatAll("[ TK_Punishment ] %N прощён", target);
	}
	else if (x == 2)
	{
		ForcePlayerSuicide(target);
		PrintToChatAll("[ TK_Punishment ] %N убит за TeamKill", target);
	}
	else if (x == 3)
	{
		decl ent;
		for (new slot = 0; slot < 4; slot++)
		{
			while ((ent = GetPlayerWeaponSlot(target, slot)) > 0) RemovePlayerItem(target, ent);
		}
		PrintToChatAll("[ TK_Punishment ] %N потерял всё своё оружие", target);
	}
	else if (x == 4)
	{
		IgniteEntity(target, 60.0);
		PrintToChatAll("[ TK_Punishment ] %N загорелся", target);
	}
	else if (x == 5)
	{
		new Handle:h = StartMessageOne("Fade", target);
		if (h == INVALID_HANDLE)
		{
			PrintToChat(client, "Ошибка.. Выберите другое наказание.");
			DisplayMenu(g_Menu, client, 0);
			return;
		}
		BfWriteShort(h, 100000000);
		BfWriteShort(h, 0);
		BfWriteShort(h, 0x0008);
		BfWriteByte(h, 0);
		BfWriteByte(h, 0);
		BfWriteByte(h, 0);
		BfWriteByte(h, 255);
		EndMessage();
		PrintToChatAll("[ TK_Punishment ] %N ослеплён", target);
	}
	else if (x == 6)
	{
		decl Float:wS_Pos[3];
		GetClientAbsOrigin(target, wS_Pos);
		wS_Pos[2] += 20.0;
		TeleportEntity(target, wS_Pos, NULL_VECTOR, NULL_VECTOR);
		SetEntityMoveType(target, MOVETYPE_NONE);
		PrintToChatAll("[ TK_Punishment ] %N заморожен", target);
	}
	else if (x == 7)
	{
		new cash = GetEntProp(target, Prop_Send, "m_iAccount") / 2;
		if (cash < 1)
		{
			PrintToChat(client, "У него нет денег. Выберите другое наказание.");
			DisplayMenu(g_Menu, client, 0);
			return;
		}
		SetEntProp(target, Prop_Send, "m_iAccount", cash);
		SetEntProp(client, Prop_Send, "m_iAccount", GetEntProp(client, Prop_Send, "m_iAccount") + cash);
		PrintToChatAll("[ TK_Punishment ] \"%N\" забрал у \"%N\" $%d", client, target, cash);
	}
	else if (x == 8)
	{
		if (!(GetEntityFlags(target) & FL_ONGROUND))
		{
			PrintToChat(client, "%N должен стоять на земле", target);
			DisplayMenu(g_Menu, client, 0);
			return;
		}
		decl Float:wS_Pos[3];
		GetClientAbsOrigin(target, wS_Pos);
		wS_Pos[2] -= 25.0;
		TeleportEntity(target, wS_Pos, NULL_VECTOR, NULL_VECTOR);
		SetEntityMoveType(target, MOVETYPE_NONE);
		PrintToChatAll("[ TK_Punishment ] %N застрял в земле", target);
	}
	else if (x == 9)
	{
		SetEntPropFloat(target, Prop_Data, "m_flLaggedMovementValue", 0.1);
		PrintToChatAll("[ TK_Punishment ] %N стал черепахой", target);
	}

	g_Id[client] = 0;
}